#![feature(extract_if, iter_advance_by, box_into_inner, hash_extract_if)]
#![allow(unused_macros)]

pub mod ast;
pub mod codegen;
pub mod common;
pub mod lexer;
pub mod parser;
pub mod symbol_table;
pub mod tokens;
pub mod triples;

pub fn tokenize<'a>(
    bytes: &'a [u8],
) -> Result<lexer::Tokenizer<'a>, (lexer::Tokenizer<'a>, Vec<lexer::TokenizeError>)> {
    lexer::Tokenizer::new_with_errors(bytes)
}
